#include <iostream>
#include <cstdio>
#include <deque>
using namespace std;
const int MAX_N = 60;
const int dx[4] = {-1, 0, 1, 0};
const int dy[4] = {0, 1, 0, -1};

struct elem {
	int x, y, z;
	elem() {}
	elem(int x, int y, int z):x(x), y(y), z(z) {}
};

deque<elem> och;
char a[MAX_N][MAX_N][MAX_N];
int d[MAX_N][MAX_N][MAX_N];

int main() {
	int n, m, k;
	cin >> n >> m >> k;

	for (int i = 0; i <= k + 1; i++)
		for (int j = 0; j <= n + 1; j++)
			for (int w = 0; w <= m + 1; w++)
				a[j][w][i] = '.';
	
	for (int i = 1; i <= k; i++)
		for (int x = 1; x <= n; x++)
			for (int y = 1; y <= m; y++)
				cin >> a[x][y][i];

	for (int i = 0; i <= n + 1; i++)
		for (int j = 0; j <= m + 1; j++) {
			och.push_back(elem(i, j, 0));
			och.push_back(elem(i, j, k + 1));
			d[i][j][0] = d[i][j][k + 1] = 1;
		}
	for (int i = 0; i <= k + 1; i++)
		for (int j = 0; j <= m + 1; j++) {
			och.push_back(elem(0, j, i));
			och.push_back(elem(n + 1, j, i));
			d[0][j][i] = d[n + 1][j][i] = 1;
		}
	for (int i = 0; i <= k + 1; i++)
		for (int j = 0; j <= n + 1; j++) {
			och.push_back(elem(j, 0, i));
			och.push_back(elem(j, m + 1, i));
			d[j][0][i] = d[j][m + 1][i] = 1;
		}


	while (och.size() != 0)	{
		elem v = och[0];
		och.pop_front();
		for (int q = 0; q < 4; q++) {
			int new_x = v.x + dx[q];
			int new_y = v.y + dy[q];
			if (new_x > 0 && new_y > 0 && new_x <= n && new_y <= m)	{
				if (a[new_x][new_y][v.z] == '#') 
					d[new_x][new_y][v.z] = 2;
				else {
					if (d[new_x][new_y][v.z] == 0) {
						d[new_x][new_y][v.z] = 1;
						och.push_back(elem(new_x, new_y, v.z));
					}
				}
			}
		}

		if (v.z - 1 > 0) {
			if (a[v.x][v.y][v.z - 1] == '#') 
				d[v.x][v.y][v.z - 1] = 2;
			else {
				if (d[v.x][v.y][v.z - 1] == 0) {
					d[v.x][v.y][v.z - 1] = 1;
					och.push_back(elem(v.x, v.y, v.z - 1));
				}
			}
		}

		if (v.z + 1 < k + 1) {
			if (a[v.x][v.y][v.z + 1] == '#') 
				d[v.x][v.y][v.z + 1] = 2;
			else {
				if (d[v.x][v.y][v.z + 1] == 0) {
					d[v.x][v.y][v.z + 1] = 1;
					och.push_back(elem(v.x, v.y, v.z + 1));
				}
			}
		}
	}

	int cnt = 0;
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= m; j++)
			for (int q = 1; q <= k; q++)
				if (a[i][j][q] == '#' && d[i][j][q] != 2) cnt++;

	cout << cnt;
	return 0;
}
