#include <iostream>
#include <cstdio>
using namespace std;

long long const MODULE = 31313131;

long long gcd(long long a, long long b) {
	while (a && b)
		if (a>b) a%=b;
		else b%=a;
	return a+b;
}

int main() {
	long long a,b;
	cin>>a>>b;

	long long N = gcd(a,b);

	if (N <= 2) {
		cout<<(1 % MODULE);
		return 0;
	}

	N-=2;

	long long A[2][2],B[2][2],C[2][2];
	A[0][0] = A[0][1] = A[1][0] = 1;
	A[1][1] = 0;

	B[0][0] = B[1][1] = 1;
	B[0][1] = B[1][0] = 0;

	while (N) {
		if (N&1) {
			for (int i=0; i<2; i++)
				for (int j=0; j<2; j++) {
					C[i][j] = 0;
					for (int k=0; k<2; k++)
						C[i][j] = (C[i][j] + B[i][k] * A[k][j]) % MODULE;
				}
			for (int i=0; i<2; i++)
				for (int j=0; j<2; j++)
					B[i][j] = C[i][j];
		}

		N>>=1;

		if (N) {
			for (int i=0; i<2; i++)
				for (int j=0; j<2; j++) {
					C[i][j] = 0;
					for (int k=0; k<2; k++)
						C[i][j] = (C[i][j] + A[i][k] * A[k][j]) % MODULE;
				}
			for (int i=0; i<2; i++)
				for (int j=0; j<2; j++)
					A[i][j] = C[i][j];
		}
	}

	cout<<((B[0][0] + B[0][1]) % MODULE);

	return 0;
}
