#include <iostream>
#include <cstdio>
using namespace std;

int const MAX_N = 1100;
long long const INF = 1000000000000000000LL;

long long s[MAX_N];

int main() {
	freopen("input.txt","r",stdin);
	freopen("output.txt","w",stdout);

	int n;
	cin>>n;
	for (int i=0; i<n; i++) {
		long long x;
		cin>>x;

		s[i] = x;
	}

	int m;
	cin>>m;
	for (int i=0; i<m; i++) {
		int tp;
		cin>>tp;

		if (tp == 0) {
			int v1,v2;
			long long prodal;
			cin>>v1>>v2>>prodal;
			v1--; v2--;

			s[v1] -= prodal;
			s[v2] += prodal;
		}
		else if (tp == 1) {
			int v1,v2;
			cin>>v1>>v2;
			v1--; v2--;

			long long mx = -INF;
			long long mn = INF;

			for (int j=v1; j<=v2; j++) {
				mx = max(mx, s[j]);
				mn = min(mn, s[j]);
			}

			cout<<(mx-mn)<<"\n";
		}
	}

	return 0;
}